#!/bin/sh
. /srv/www/include/cgi-helper
CONFFILE="/etc/hvac.conf"
if [ -f $CONFFILE ]; then
. $CONFFILE
fi
OW_CONFFILE="/var/run/ow.conf"
if [ -f $OW_CONFFILE ]; then
. $OW_CONFFILE
fi
TMPFILE="/tmp/hvac.tmp"
if [ -f $TMPFILE ]; then
. $TMPFILE
else
echo "LLWT_RUN='no'" > $TMPFILE
echo "WLWT_RUN='no'" >> $TMPFILE
. $TMPFILE
fi
HVAC_DIR="/data/hvac"
JAHR=`date +%y`
MONAT=`date +%m`
PRIMO="01.$MONAT.$JAHR"
LOGFILE="$HVAC_DIR/hvac-$JAHR.log"
redraw ()
{
if [ -n "$1" ]; then
ACTION=$1
echo "<script>window.location.href = \"$myname?action=$ACTION\"</script>"
else 
echo "<script>window.location.href = \"$myname\"</script>"
fi
}
header ()
{
RTIME=$1
show_html_header "$MP_HVAC" "refresh=$RTIME; url=$myname"
}
DS1920_temp ()
{
if [ -f "$OW_OWFS_PATH/$1/temperature" ]; then
temp=`cat $OW_OWFS_PATH/$1/temperature`
temp1=`echo $temp | cut -d. -f1`
temp2=`echo $temp | cut -d. -f2 | cut -c1`
temp="$temp1.$temp2"
if [ $temp -lt 10 ]
then
temp=0$temp
fi
echo "$temp C"
else
echo "n.n."
fi
}
DS2423_cnt ()
{
if [ -f "$OW_OWFS_PATH/$1/counters.$2" ]; then
cnt=`cat $OW_OWFS_PATH/$1/counters.$2`
cnt=$(echo "scale=$3; ($cnt + $5) / $4" | bc )
echo "$cnt"
else
echo "n.n."
fi
}
DS2413_piox ()
{
if [ -d "$OW_OWFS_PATH/$1" ]; then
case $2 in
A|a)
case $3 in
on|1) echo "1" > $OW_OWFS_PATH/$1/PIO.A ;; 
off|0) echo "0" > $OW_OWFS_PATH/$1/PIO.A ;;
esac ;; 
B|b)
case $3 in
on|1) echo "1" > $OW_OWFS_PATH/$1/PIO.B ;; 
off|0) echo "0" > $OW_OWFS_PATH/$1/PIO.B ;;
esac ;;
esac
else
show_error "Fehler:" "$1 nicht gefunden.<br /></b>"
fi
}
MP_HVAC="HVAC"
RTIME=2
gr="bgcolor=\"#73AF8C\""
rt="bgcolor=\"#FF0000\""
t_frischluft=`DS1920_temp 10.D3F5A8010800`
t_fortluft=`DS1920_temp 10.021DA9010800`
t_abluft=`DS1920_temp 10.7C08A9010800`
t_zuluft=`DS1920_temp 10.F31CA9010800`
t_heizluft=`DS1920_temp 10.C715A9010800`
t_rueckluft=`DS1920_temp 10.4221A9010800`
t_hzgvl=`DS1920_temp 10.2532A9010800`
t_hzgrl=`DS1920_temp 10.2C2DA9010800`
t_heizraum=`DS1920_temp 10.0E4BA9010800`
gas=`DS2423_cnt 1D.B9820E000000 A 2 100 $HVAC_CNT_01`
kon=`DS2423_cnt 1D.B9820E000000 B 1 210 $HVAC_CNT_02`
qA=$(echo "scale=1; 13.5-8.4375*$kon/$gas"|bc)

gas_primo=`sed -n 's/'"$PRIMO"'/&/p' $LOGFILE | cut -d " " -f5`
gas_monat=$(echo "scale=2; $gas-$gas_primo"|bc) 
kon_primo=`sed -n 's/'"$PRIMO"'/&/p' $LOGFILE | cut -d " " -f7`
kon_monat=$(echo "scale=1; $kon-$kon_primo"|bc) 
qA_monat=$(echo "scale=1; 13.5-8.4375*$kon_monat/$gas_monat"|bc)

gas_nox=`sed '$!d' $LOGFILE | cut -d " " -f5`
gas_heute=$(echo "scale=2; $gas-$gas_nox"|bc) 
kon_nox=`sed '$!d' $LOGFILE | cut -d " " -f7`
kon_heute=$(echo "scale=1; $kon-$kon_nox"|bc) 
qA_heute=$(echo "scale=1; 13.5-8.4375*$kon_heute/$gas_heute"|bc)

gas_praenox=`sed -e '1{$d;}' -e '$!{h;d;}' -e x $LOGFILE | cut -d " " -f5`
gas_gestern=$(echo "scale=2; $gas_nox-$gas_praenox"|bc) 
kon_praenox=`sed -e '1{$d;}' -e '$!{h;d;}' -e x $LOGFILE | cut -d " " -f7`
kon_gestern=$(echo "scale=1; $kon_nox-$kon_praenox"|bc) 
qA_gestern=$(echo "scale=1; 13.5-8.4375*$kon_gestern/$gas_gestern"|bc)

: ${FORM_action:=status}
_status="Status"
header
show_tab_header \
 "$_status" "$myname?action=status" \

case $FORM_action in
LLWT_stop)
sed /LLWT_RUN/s/yes/no/ $TMPFILE > /tmp/hvac
cat /tmp/hvac > $TMPFILE
redraw
;;
LLWT_start)
sed /LLWT_RUN/s/no/yes/ $TMPFILE > /tmp/hvac
cat /tmp/hvac > $TMPFILE
redraw
;;
WLWT_stop)
sed /WLWT_RUN/s/yes/no/ $TMPFILE > /tmp/hvac
cat /tmp/hvac > $TMPFILE
redraw
;;
WLWT_start)
sed /WLWT_RUN/s/no/yes/ $TMPFILE > /tmp/hvac
cat /tmp/hvac > $TMPFILE
redraw
;;
status)
if [ "$OW_OWFS_RUN" == "yes" ]; then
echo '<div>'
echo '<img alt="schedule" src= "../img/hvac/sched.png">'
case $WLWT_RUN in
yes) echo "<div id='p1'><a href=\"$myname?action=WLWT_stop\">
              <img src='../img/hvac/vent_bg.gif' alt="stop"></a></div>" ;;
*) echo "<div id='p1'><a href=\"$myname?action=WLWT_start\">
              <img src='../img/hvac/vent_bg.png' alt="start"></a></div>" ;;
esac
case $LLWT_RUN in
yes) echo "<div id='p3'><a href=\"$myname?action=LLWT_stop\">
              <img src='../img/hvac/vent_sm.gif' alt="stop"></a></div>" ;;
*) echo "<div id='p3'><a href=\"$myname?action=LLWT_start\">
              <img src='../img/hvac/vent_sm.png' alt="start"></a></div>" ;;
esac
echo '<div id="p5"><img alt"-" src="../img/hvac/pump.png"></div>'
echo "<div id='t01'>"$t_frischluft"</div>"
echo "<div id='t02'>"$t_fortluft"</div>"
echo "<div id='t03'>"$t_abluft"</div>"
echo "<div id='t04'>"$t_zuluft"</div>"
echo "<div id='t05'>"$t_hzgvl"</div>"
echo "<div id='t06'>"$t_hzgrl"</div>"
echo "<div id='t07'>"$t_abluft"</div>"
echo "<div id='t08'>"$t_heizluft"</div>"
echo "<div id='t09'>"$t_rueckluft"</div>"
echo "<div id='t10'>"$t_heizraum"</div>"
echo '</div>'
echo "<div id='tbl1'><table class='sdtable'>"
echo "<tr><th colspan=2 >Gas</th><th colspan=2 >Kondensat</th><th colspan=2 >qA</th><th colspan=2 >Zeit</th></tr>"
echo "<tr><td colspan=2 >$gas m</td><td colspan=2>$kon l</td><td colspan=2>$qA %</td><td colspan=2>Gesamt</td></tr>"
echo "<tr><td colspan=2 >$gas_monat m</td><td colspan=2>$kon_monat l</td><td colspan=2>$qA_monat %</td><td colspan=2>Monat</td></tr>"
echo "<tr><td colspan=2 >$gas_gestern m</td><td colspan=2>$kon_gestern l</td><td colspan=2>$qA_gestern %</td><td colspan=2>Gestern</td></tr>"
echo "<tr><td colspan=2 >$gas_heute m</td><td colspan=2>$kon_heute l</td><td colspan=2>$qA_heute %</td><td colspan=2>Heute</td></tr>"
echo '</table></div>'
echo '<div>'
echo '<img alt="24h" src="../admin/owfs/1D.B9820E000000-counters.A+1D.B9820E000000-counters.B-e-24h.png">'
echo '<img alt="24h" src="../admin/owfs/10.C715A9010800-temperature+10.4221A9010800-temperature+10.2532A9010800-temperature+10.2C2DA9010800-temperature-e-24h.png">'
echo '<img alt="24h" src="../admin/owfs/10.D3F5A8010800-temperature+10.021DA9010800-temperature+10.7C08A9010800-temperature+10.F31CA9010800-temperature-e-24h.png">'
echo '</div>'
# echo "$gas_praenox"
else
show_error "Hinweis:" "<b>\"OWFS\" ist nicht aktiviert.<br /></b>"
fi
;;
esac
show_tab_footer
show_html_footer
